# -*- coding=utf-8 -*-
from aptdaemon import client
from aptdaemon.errors import NotAuthorizedError, TransactionFailed
from gi.repository import GObject
import socket
import sys
import aptdaemon.loop

port=8788

if len(sys.argv) > 1:
        port = int(sys.argv[1])


loop = GObject.MainLoop()
address = ('127.0.0.1', port)
s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
isfinished=False

def sendMsg(o, msg):
        s.sendto(msg.encode(), address)
        
class Installer(GObject.GObject):
        __gsignals__ = {
                'sendMsg': (GObject.SIGNAL_RUN_FIRST, None,
                              (GObject.TYPE_STRING,))
                }
        def __init__(self):
                GObject.GObject.__init__(self)
                self.apt_client = client.AptClient()
                self.transaction = None
                self.connect('sendMsg', sendMsg)
        def install(self, pkgs):
                try:
                    self.transaction = None
                    self.transaction = self.apt_client.install_packages(pkgs)
                    self.transaction.set_allow_unauthenticated(allow_unauthenticated=2)
                    self.transaction.connect("progress-changed", self.change_progress)
                    self.transaction.connect("finished", self.finished)
                    self.transaction.connect("error", self.on_error)
                    self.transaction.run()
                    aptdaemon.loop.mainloop.run()
                except(NotAuthorizedError, TransactionFailed, Exception) as e:
                    if (e.__class__.__name__ == 'NotAuthorizedError' or e.__class__.__name__ == 'DBusException'):
                       msg = '-01' + '4'+pkgs[0]
                       self.emit('sendMsg', msg)
                       print(msg)
                    print("Warning: install transaction not completed successfully: {}")
                    aptdaemon.loop.mainloop.quit()
        def remove(self, pkgs):
                try:
                    self.transaction = self.apt_client.remove_packages(pkgs)
                    self.transaction.set_allow_unauthenticated(allow_unauthenticated=2)
                    self.transaction.connect("progress-changed", self.change_progress)
                    self.transaction.connect("finished", self.finished)
                    self.transaction.connect("error", self.on_error)
                    self.transaction.run()
                    aptdaemon.loop.mainloop.run()
                except(NotAuthorizedError, TransactionFailed, Exception) as e:
                    if (e.__class__.__name__ == 'NotAuthorizedError' or e.__class__.__name__ == 'DBusException'):
                       msg = '-01' + '4'+pkgs[0]
                       self.emit('sendMsg', msg)
                       print(msg)
                    print("Warning: install transaction not completed successfully: {}")
                    aptdaemon.loop.mainloop.quit()

                        
        def change_progress(self, tr, pr):
                pkgs = [];
                pkgs.extend(tr.packages[0])
                pkgs.extend(tr.packages[1])
                pkgs.extend(tr.packages[2])
                pkgs.extend(tr.packages[3])
                pkgs.extend(tr.packages[4])

                print(pkgs)
                if pr <= 100 and pr > 0:
                    msg = format(pr, '03d') + '1'+pkgs[0]
                    print(msg )
                    self.emit('sendMsg', msg)


        def finished(self, tr, exit_status):
                pkgs = [];
                pkgs.extend(tr.packages[0])
                pkgs.extend(tr.packages[1])
                pkgs.extend(tr.packages[2])
                pkgs.extend(tr.packages[3])
                pkgs.extend(tr.packages[4])
                global s
                isfinished = True
                if exit_status != 'exit-failed':
                    msg = '100'+ '2'+pkgs[0]
                    print(msg + " " + exit_status)
                    self.emit('sendMsg', msg)
                aptdaemon.loop.mainloop.quit()

        def on_error(self, tr, error_code, error_details):
                pkgs = [];
                pkgs.extend(tr.packages[0])
                pkgs.extend(tr.packages[1])
                pkgs.extend(tr.packages[2])
                pkgs.extend(tr.packages[3])
                pkgs.extend(tr.packages[4])
                if error_code != 'error-not-authorized':
                    msg = '000' + '3'+pkgs[0]
                    print(msg)
                    self.emit('sendMsg', msg)
                aptdaemon.loop.mainloop.quit()


i = Installer()
while(True):
    cmd = input();
    if len(cmd) > 0:
        if 'exit'==cmd:
           break;
        cmdArr = cmd.split();
        if len(cmdArr) > 1:
           c = cmdArr[0]
           pgks = cmdArr[1:]
           if 'install' == c:
               i.install(pgks);
           elif 'update' == c:
               i.install(pgks);
           elif 'remove' == c:
               i.remove(pgks);

           




