# -*- coding=utf-8 -*-
from aptdaemon import client
from aptdaemon.errors import NotAuthorizedError, TransactionFailed
from gi.repository import GObject
import socket
import sys
import aptdaemon.loop
import signal
import threading
import apt_pkg
import re
import urllib
from math import ceil

isDown = False;

# %:if first  is digit progress

port=8867
FLAG_finished  = 0;
FLAG_on_error = 0;
preval = 0;     # 用于备份进度输出时的去重
if len(sys.argv) > 1:
        port = int(sys.argv[1])


loop = GObject.MainLoop()
address = ('127.0.0.1', port)
s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)

def sendMsg(o, msg):
        s.sendto(msg.encode(), address)

def backfunc(a, b, c):
        global preval;
        prog = 100 * a * b / c;
        if prog > 100:
              prog = 100;
        prog = int(ceil(prog));
        if(prog > preval):
                msg = aptdaemonAction.taskId + ";" + aptdaemonAction.actionType + ";download-progress;" + str(prog);
                print('%s' % msg);
                aptdaemonAction.emit('sendMsg', msg);
                preval = prog;
                if prog == 100:
                    msg = aptdaemonAction.taskId + ";" + aptdaemonAction.actionType + ";exit-status;" + "exit-success";
                    print('%s' % msg);
                    aptdaemonAction.emit('sendMsg', msg);
        
class AptdaemonAction(GObject.GObject):
        __gsignals__ = {
                'sendMsg': (GObject.SIGNAL_RUN_FIRST, None,
                              (GObject.TYPE_STRING,))
                }
        def __init__(self):
                GObject.GObject.__init__(self)
                self.apt_client = client.AptClient()
                self.connect('sendMsg', sendMsg)
                signal.signal(signal.SIGUSR1, self.sigint_handler)

        def init_data(self):
                self.transaction = None
                self.action = ""
                self.actionType = ""
                self.taskId = ""
                self.packageName = ""
                self.status = ""
                self.bytes_done = ""
                self.bytes_total = ""
                self.speed = ""
                self.progress = ""
                self.pause = ""
                self.cancel = ""
                self.error_details = ""                

        def install(self, pkgs):
                try:
                        pkgAndTaskId = pkgs[0].split(';')
                        self.init_data()
                        global FLAG_finished
                        global FLAG_on_error
                        FLAG_finished = 0;
                        FLAG_on_error = 0;
                        if len(pkgAndTaskId) > 1:
                             self.taskId = pkgAndTaskId[1];
                        self.packageName =pkgAndTaskId[0]
                        packageNames = [self.packageName]
                        self.action = "install"
                        self.actionType = "0"
                        self.transaction = self.apt_client.install_packages(packageNames)
                        self.transaction.set_allow_unauthenticated(allow_unauthenticated=2)
                        self.transaction.connect("finished", self.finished)
                        self.transaction.connect("progress-changed", self.install_progress_changed)
                        self.transaction.connect("error", self.on_error)
                        self.transaction.connect("progress-download-changed",self.on_download_changed)
                        FLAG_finished = 1;
                        FLAG_on_error = 1;
                        self.transaction.run()
                except(NotAuthorizedError, TransactionFailed, Exception) as e:
                	pass
                aptdaemon.loop.mainloop.run()

        def drivercenterUpdate(self, pkgs):
                try:
                        pkgAndTaskId = pkgs[0].split(';')
                        self.init_data()
                        global FLAG_finished
                        global FLAG_on_error
                        FLAG_finished = 0;
                        FLAG_on_error = 0;
                        if len(pkgAndTaskId) > 1:
                             self.taskId = pkgAndTaskId[1];
                        self.packageName = pkgAndTaskId[0]
                        packageNames = [self.packageName]
                        self.action = "install"
                        self.actionType = "2"
                        self.transaction = self.apt_client.install_packages(packageNames)
                        self.transaction.set_allow_unauthenticated(allow_unauthenticated=2)
                        self.transaction.connect("finished", self.finished)
                        self.transaction.connect("error", self.on_error)
                        FLAG_finished = 1;
                        FLAG_on_error = 1;
                        self.transaction.run()
                except(NotAuthorizedError, TransactionFailed, Exception) as e:
                        pass
                aptdaemon.loop.mainloop.run()

        def remove(self, pkgs):
                try:                        
                        self.init_data();
                        pkgAndTaskId = pkgs[0].split(';');
                        if len(pkgAndTaskId) > 1:
                             self.taskId = pkgAndTaskId[1];
                        self.packageName =pkgAndTaskId[0];
                        self.action = "remove"
                        self.actionType = "1"
                        global FLAG_finished
                        global FLAG_on_error
                        FLAG_finished = 0;
                        FLAG_on_error = 0;
                        self.transaction =self.apt_client.commit_packages(install=[], remove=[],
                                                         reinstall=[], purge=[self.packageName], upgrade=[], downgrade=[])
                        #self.transaction = self.apt_client.remove_packages(pkgs)
                        self.transaction.set_allow_unauthenticated(allow_unauthenticated=2)
                        self.transaction.connect("progress-changed", self.remove_progress_changed)
                        self.transaction.connect("finished", self.finished)
                        self.transaction.connect("error", self.on_error)
                        FLAG_finished = 1;
                        FLAG_on_error = 1;
                        self.transaction.run()
                except(NotAuthorizedError, TransactionFailed, Exception) as e:                        
                        pass
                aptdaemon.loop.mainloop.run()
     
        def on_download_changed(self, transaction, uri, status, desc, full_size, downloaded, message):
                try:
                        progress = int(downloaded * 100 / full_size)
                except ZeroDivisionError:
                        progress = -1
                if progress > 100:
                        progress = 100;

                global isDown;
                if progress >=0 or progress <100:
                        isDown = True;
                else:
                        isDown = False;
                msg = "%s%s%s%s%s%s%d"%(self.taskId,";",self.actionType,";",self.packageName,";download-progress;",progress);
                self.emit('sendMsg', msg)
                print("emit: " + msg);
                        
        def reply_handler(self):
                print("not emit: reply_handler")
                
        def error_handler(self, error):
                print("not emit: error_handler")
                print("not emit: " + error)
                        
        def cancell(self, pkgs):
                pkgAndTaskId = pkgs[0].split(';')
                if len(pkgAndTaskId) > 1:
                        self.taskId = pkgAndTaskId[1];
                self.packageName =pkgAndTaskId[0]
                self.action = "cancel"
                self.actionType = "5"
                if self.transaction:
                        self.transaction.cancel(self.reply_handler, self.error_handler)
                        self.transaction = None
                       
        def pausee(self):
                self.action = "pause"
                self.actionType = "6"
                if self.transaction:
                        self.transaction.cancel(self.reply_handler, self.error_handler)
                        self.transaction = None

        def finished(self, tr, exit_status):
                if exit_status == 'exit-failed':
                    msg = self.taskId + ";" + self.actionType + ";" + self.packageName + ";exit-status;" + exit_status + ";" + self.error_details
                else:
                    msg = self.taskId + ";" + self.actionType + ";" + self.packageName + ";exit-status;" + exit_status
                print("emit: " + msg)
                self.emit('sendMsg',msg)
                aptdaemon.loop.mainloop.quit()

        def on_error(self, tr, error_code, error_details):
                print("not emit: " + self.error_details)
                self.error_details = error_code

        def install_progress_changed(self, tr, progress):
                msg = self.taskId + ";" + self.actionType + ";" + self.packageName + ";install-status;" + tr.status + ";install-status-details;" +  tr.status_details
                #print("emit: " + msg)
                if tr.status != "status-downloading" and tr.status != "status-finished":
                	print("emit: " + msg)
                	self.emit('sendMsg', msg)
                else:
                	print("not emit: " + msg)

        def remove_progress_changed(self, tr, progress):
                msg = "%s%s%s%s%s%s%d"%(self.taskId,";",self.actionType,";",self.packageName,";remove-progress;",progress);
                print("emit: " + msg)
                self.emit('sendMsg', msg)

        def sigint_handler(self,signum, frame):
                self.transaction.cancellabe = True;
                self.transaction.cancel();

        def update_cache(self, pkgs):
                print("update_cache")
                try:
                        pkgAndTaskId = pkgs[0].split(';')
                        self.init_data()
                        if len(pkgAndTaskId) > 1:
                             self.taskId = pkgAndTaskId[1];
                        self.packageName =pkgAndTaskId[0]
                        packageNames = [self.packageName]
                        self.action = "update"
                        self.actionType = "9"
                        #repo_local_path = 'local-drivercenter.list'
                        #print (pkgAndTaskId[0])
                        self.transaction = self.apt_client.update_cache(pkgAndTaskId[0])
                        self.transaction.set_allow_unauthenticated(allow_unauthenticated=2)               
                        self.transaction.connect("finished", self.finished)
                        self.transaction.connect("error", self.on_error)
                        self.transaction.run()
                except(NotAuthorizedError, TransactionFailed, Exception) as e:
                	print(e)
                	pass
                aptdaemon.loop.mainloop.run()

        def backup(self, pkgs):                           
                args   = pkgs[0].split(';');
                source = args[0];
                dist   = args[1];
                url    = args[2];
                self.actionType = "3"
                self.taskId  = args[3];
                try:
                       urllib.request.urlretrieve(source, dist, backfunc);
                except(Exception) as e:
                       print(e);
                       try:
                              urllib.request.urlretrieve(url, dist, backfunc);
                       except(Exception) as e:
                              print(e);
                              msg = aptdaemonAction.taskId + ";" + aptdaemonAction.actionType + ";exit-status;" + "exit-fail";
                              print('%s' % msg);
                              self.emit('sendMsg', msg);
        
        def restore(self, pkgs):
                self.init_data()
                try:
                        args            = pkgs[0].split(';');
                        file            = args[0];
                        self.taskId     = args[1];
                        self.actionType = "4";
                        self.transaction = self.apt_client.install_file(file,force=True);
                        self.transaction.set_allow_unauthenticated(allow_unauthenticated=2)
                        self.transaction.connect("progress-changed", self.restore_progress_changed)
                        #self.transaction.connect("progress-details-changed", self.restore_details_changed)
                        self.transaction.connect("finished", self.finished)
                        self.transaction.connect("error", self.on_error)                
                        self.transaction.run()
                except(Exception) as e:
                	print(e)
                	pass
                aptdaemon.loop.mainloop.run()

        def restore_progress_changed(self, tr, progress):
                msg = self.taskId + ";" + self.actionType + ";restore-status;" + tr.status + ";restore-status-details;" +  tr.status_details
                print("emit: " + msg)
                self.emit('sendMsg', msg)
                #print("%d" % progress);
      
  

aptdaemonAction = AptdaemonAction()

def operating(cmd):
        cmdArr = cmd.split()
        if len(cmdArr) >= 1:
                c = cmdArr[0]
                args = cmdArr[1:]
                if '0' == c:
                        aptdaemonAction.install(args)
                elif '1' == c:
                        aptdaemonAction.remove(args)
                elif '2' == c:
                        aptdaemonAction.drivercenterUpdate(args)
                elif '3' == c:
                        aptdaemonAction.backup(args)
                elif '4' == c:
                        aptdaemonAction.restore(args);
                elif '9' == c:
                        aptdaemonAction.update_cache(args)

while(True):
    cmd = input();
    if len(cmd) > 0:
        p = re.compile('^[0-9]')
        if p.match(cmd) != "None":
                if cmd.split()[0] == "5":
                	aptdaemonAction.cancell(cmd.split()[1:])
                else:
                	myThread = threading.Thread(target = operating, args=(cmd, ))
                	myThread.start()	
        else:        
                if 'exit'==cmd.split()[0]:
                	break;
                if 'pause' == cmd.split()[0]:
                	aptdaemonAction.pausee()


