#! /bin/sh
#$1, action_type
#    SOURCE_LOCAL_ENABLE, 0
#    SOURCE_LOCAL_DISABLE, 1
#    SOURCE_LOCAL_DISABLE_ALL, 2
#    SOURCE_NET_ENABLE, 3
#    SOURCE_NET_DISABLE 4
#$2, path
local='/etc/apt/sources.list.d/drivercenter_local.list'
net='/etc/apt/sources.list.d/drivercenter_network.list'
enableLocal()
{
	echo "enableLocal"
	echo $1
	#/media/xiemx/ADATA/drivercenter/
	num=`grep "$1" $local | wc -l`
	if [ $num -ne 0 ];then
		sed -i "s;^#\(deb\s$1\);\1;" $local
	else
		#sed -i "/$/a deb $1 packs/" $local
		echo "deb $1 packs/">>$local
	fi	
}

disableLocal()
{
	echo "disableLocal"
	echo $1
	sed -i "s;^\(deb\s$1\);#\1;g" $local
}

disableLocalAll()
{
	echo "disableLocalAll"
	sed -i 's/^\(deb\sfile\)/#\1/g' $local
}
enableNet()
{
	echo "enableNet"
	sed -i 's/^#\(deb\shttp\)/\1/g' $net
}
disableNet()
{
	echo "disableNet"
	sed -i 's/^\(deb\shttp\)/#\1/g' $net
}
#start
set -x
res=0
if [ -e $2 ];then
	if [ ! -e $2/drivercenter/packs ];then
		mkdir -p $2/drivercenter/packs	
		res=$?
	fi
else
	res=2
	exit $res
fi
path='file://'$2'drivercenter/'
case $1 in
0)
	#echo "source_local_enable"
	disableLocalAll
	enableLocal $path
	res=$?	
	echo 'res: '$res
;;
1)
	#echo "source_local_disable"
	disableLocal $path
	res=$?	
	echo 'res: '$res
;;
2)
	#echo "source_local_disable_all"
	disableLocalAll
	res=$?	
	echo 'res: '$res
;;
3)
	#echo "source_net_enable"
	enableNet
	res=$?	
	echo 'res: '$res
;;
4)
	#echo "source_net_disable"
	disableNet
	res=$?	
	echo 'res: '$res
;;
*)
	#echo "source_error"
	res=2	
	echo 'res: '$res
;;
esac
set +x
exit $res
