# -*- coding=utf-8 -*-
from aptdaemon import client
from aptdaemon.errors import NotAuthorizedError, TransactionFailed
from gi.repository import GObject
import socket
import sys
import aptdaemon.loop
import signal

isDown = False;

# %:if first  is digit progress

port=8888
FLAG_finished  = 0;
FLAG_on_error = 0;
if len(sys.argv) > 1:
        port = int(sys.argv[1])


loop = GObject.MainLoop()
address = ('127.0.0.1', port)
s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
isfinished=False

def sendMsg(o, msg):
        s.sendto(msg.encode(), address)
        
class Installer(GObject.GObject):
        __gsignals__ = {
                'sendMsg': (GObject.SIGNAL_RUN_FIRST, None,
                              (GObject.TYPE_STRING,))
                }
        def __init__(self):
                GObject.GObject.__init__(self)
                self.apt_client = client.AptClient()
                self.transaction = None
                self.connect('sendMsg', sendMsg)
                signal.signal(signal.SIGUSR1, self.sigint_handler)
        def install(self, pkgs):
                try:
                    self.transaction = None
                    global FLAG_finished
                    global FLAG_on_error
                    FLAG_finished = 0;
                    FLAG_on_error = 0;
                    self.transaction = self.apt_client.install_packages(pkgs)
                    self.transaction.set_allow_unauthenticated(allow_unauthenticated=2)                    
                    self.transaction.connect("finished", self.finished)
                    self.transaction.connect("error", self.on_error)
                    self.transaction.connect("progress-download-changed",self.on_download_changed)
                    FLAG_finished = 1;
                    FLAG_on_error = 1;
                    self.transaction.run()
                    aptdaemon.loop.mainloop.run()
                except(NotAuthorizedError, TransactionFailed, Exception) as e:
                    msg = pkgs[0] + ":" + e.__class__.__name__
                    self.emit('sendMsg', msg)
                    print(msg)
                    
                    aptdaemon.loop.mainloop.quit()
        def remove(self, pkgs):
                try:
                    print("start remove: " +  pkgs[0])
                    self.transaction = None
                    self.action = ""
                    self.packageName = ""
                    self.status = ""
                    self.bytes_done = ""
                    self.bytes_total = ""
                    self.speed = ""
                    self.progress = ""
                    self.pause = ""
                    self.cancel = ""
                    self.error_details = ""
                    self.action = "remove"
                    global FLAG_finished
                    global FLAG_on_error
                    FLAG_finished = 0;
                    FLAG_on_error = 0;
                    self.packageName = pkgs[0]
                    self.transaction = self.apt_client.remove_packages(pkgs)
                    self.transaction.set_allow_unauthenticated(allow_unauthenticated=2)
                    self.transaction.connect("progress-changed", self.change_progress)
                    self.transaction.connect("finished", self.finished)
                    self.transaction.connect("error", self.on_error)
                    FLAG_finished = 1;
                    FLAG_on_error = 1;
                    self.transaction.run()
                except(NotAuthorizedError, TransactionFailed, Exception) as e:
                        msg = pkgs[0] + ":" + e.__class__.__name__
                        self.emit('sendMsg', msg)
                        print(e)
                aptdaemon.loop.mainloop.run()        

        def finished(self, tr, exit_status):
                pkgs = [];
                pkgs.extend(tr.packages[0])
                pkgs.extend(tr.packages[1])
                pkgs.extend(tr.packages[2])
                pkgs.extend(tr.packages[3])
                pkgs.extend(tr.packages[4])
                global FLAG_finished
                if FLAG_finished ==1:
                    msg = pkgs[0] + ":" + exit_status
                    print(msg)
                    self.emit('sendMsg',msg)
                    FLAG_finished = 0
                aptdaemon.loop.mainloop.quit()

        def on_error(self, tr, error_code, error_details):
                pkgs = [];
                pkgs.extend(tr.packages[0])
                pkgs.extend(tr.packages[1])
                pkgs.extend(tr.packages[2])
                pkgs.extend(tr.packages[3])
                pkgs.extend(tr.packages[4])
                global FLAG_on_error
                if FLAG_on_error ==1:
                    msg = pkgs[0] +":"+ error_code
                    print(msg)
                    self.emit('sendMsg', msg)
                    FLAG_on_error = 0
                aptdaemon.loop.mainloop.quit()
        def on_download_changed(self, transaction, uri, status, desc, full_size, downloaded, message):
                pkgs = [];
                pkgs.extend(transaction.packages[0])
                pkgs.extend(transaction.packages[1])
                pkgs.extend(transaction.packages[2])
                pkgs.extend(transaction.packages[3])
                pkgs.extend(transaction.packages[4])
                try:
                    progress = int(downloaded * 100 / full_size)
                except ZeroDivisionError:
                    progress = -1
                if progress > 100:
                    progress = 100;

                global isDown;
                if progress >=0 or progress <100:
                    isDown = True;
                else:
                    isDown = False;

                print(progress);
                print(status);
                #msg =pkgs[0] +":"+ str(progress);
                #msg = string(progress);
                msg = "%s%s%s%d"%(pkgs[0],":","#",progress);
                print(msg);
                self.emit('sendMsg', msg)
                
        def change_progress(self, tr, pr):                
                if pr < 45 and pr > 0:
                        msg = self.action + ";"+self.packageName + ";" + "inprogress;" + self.bytes_done + ";"+self.bytes_total+";"+self.speed + ";"+ format(pr, '03d') + ";"+ "yes;" +"yes;";
                        self.emit('sendMsg', msg)
                        print(msg) 
                elif pr >= 45 and pr <= 100:
                        msg = self.action + ";"+self.packageName + ";" + "inprogress;" + self.bytes_done + ";"+self.bytes_total+";"+self.speed + ";"+ format(pr, '03d') + ";"+ "no;" +"no;";
                        self.emit('sendMsg', msg)
                        print(msg) 

        def sigint_handler(self,signum, frame):
                self.transaction.cancellabe = True;
                self.transaction.cancel();



i = Installer()
while(True):
    cmd = input();
    if len(cmd) > 0:
        if 'exit'==cmd:
           break;
        cmdArr = cmd.split();
        if len(cmdArr) > 1:
           c = cmdArr[0]
           pgks = cmdArr[1:]
           if 'install' == c:
               i.install(pgks);
           elif 'update' == c:
               i.install(pgks);
           elif 'remove' == c:
               i.remove(pgks);

           




